#ifndef THREAD_H
#define THREAD_H

#include <QObject>
#include <QThread>
#include <QVector>
#include <QByteArray>
#include <QString>
#include <QTime>

#include "hidapi/hidapi.h"

#define DATA_POOL_INTERVAL_MS 20
#define CONNECTION_TIMEOUT_MS 1000

class Thread : public QThread
{
Q_OBJECT
public:
    Thread();
    ~Thread();
protected:
    void run();
private:
    hid_device *device;
    QAtomicInt running = 1;
    int connection_timeout = 0;
    int last_byte = -1;
    void qSleep(int ms);
    QByteArray hid_read_(void);
    QVector<int> read_data(void);
public:
    void stop(void);
signals:
    void info(const QString text);
    void data(const QVector<int> data);
};

#endif // THREAD_H
